#!/usr/bin/perl -w

# stickyserv.pl
# Copyright (C) 2003 Nicolas Fradet
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

use English ;
use strict ;

my $ConfFile='/etc/Sticky.conf' ;
my %Nom ;
my (@Tmp,%Cmd,$Trash);
my ($Length,$CtrlChars) ;
my $High=0 ;
my (@FirstLine,$Parse) ;

my @PostIt=(
"16 16 5 1",
" 	c None",
".	c #4D4D37",
"+	c #000000",
"@	c #FFFF00",
"#	c #848200",
"                ",
"     .++        ",
"     +@@++      ",
"    +@@@@@++    ",
"    +@@@@@@@+++ ",
"   +@@@@@@@@@@#+",
"   +@@@@@@@@@@#+",
"  +@@@@@@@@@@#++",
" +@@@@@@@@@@@#+ ",
"+@@@@@@@@@@@@++ ",
"+@@@@@@@@@@@#+  ",
" +@@@@@@@@@@++  ",
"  ++@@@@@@@++   ",
"    ++@@+@@+    ",
"      +++++     ",
"                ");

my @Poubelle=(
"16 16 4 1",
" 	c None",
".	c #848284",
"+	c #000000",
"@	c #C6C3C6",
"      ...       ",
"  +++++++++++   ",
" +@@@@@@@@...+  ",
"  +@.@.@.@+.+   ",
"  +@.@.@.@+.+   ",
"  +@.@.@.@+.+   ",
"  +@.@.@.@+.+   ",
"  +@.@.@.@+.+   ",
"  +@.@.@.@+.+   ",
"  +@.@.@.@+.+   ",
"  +@.@.@.@+.+   ",
"  +@.@.@.@+.+   ",
"  +@.@.@.@+.+   ",
"  +@@@@@@@@.+   ",
"   +++++++++    ",
"                ");

&SetOutput() ;

## Debug Mode
if (!$ENV{REMOTE_HOST}) {$ENV{REMOTE_HOST}="debug"}
if (!$ENV{DISPLAY}) {$ENV{DISPLAY}=":0"}



#~ system('set >> /tmp/ttt');
&LoadFriends() ;


while (<>)
	{
	 chomp ;
	 $Parse=$_ ;
	 if (/#/)
	 {
	   @FirstLine=split (' ',$Parse) ;
	   $Parse = $FirstLine[1] ;
	   ($CtrlChars,$Trash)=split ('#',$FirstLine[0]) ;
	   if (length($CtrlChars)==2)
	   {
	      $Length=ord(substr($CtrlChars,0,1)) ;
	      $High=ord(substr($CtrlChars,1,1)) ;
	   }
	   elsif (length($CtrlChars)==1)
	   {
	      $Length = ord($CtrlChars) ;
	   }
	 }
         @Tmp=split('=',$Parse) ;
         $Cmd{$Tmp[0]}=$Tmp[1] ;
      	}
	print "Length=".($Length+($High*256))."\n" ;
	if ($High) {print "High=$High\n"}
	print &ListCmd ;
	print "Remote=".$ENV{REMOTE_HOST}."\n" ;
	print "$Cmd{TEXT}\n" ;

&AffMessage($Cmd{'TEXT'},$ENV{REMOTE_HOST}) ;

&UnsetOutput() ;

sub UnsetOutput {
# close the redirected filehandles
close(STDOUT)                       or die "Can't close STDOUT: $!";
close(STDERR)                       or die "Can't close STDERR: $!";

# restore stdout and stderr
open(STDERR, ">&OLDERR")            or die "Can't restore stderr: $!";
open(STDOUT, ">&OLDOUT")            or die "Can't restore stdout: $!";

# avoid leaks by closing the independent copies
close(OLDOUT)                       or die "Can't close OLDOUT: $!";
close(OLDERR)                       or die "Can't close OLDERR: $!";
}
sub SetOutput {
## Unbufferize
select(STDOUT);$|++ ;
select(STDERR);$|++ ;

open(OLDOUT, ">&STDOUT");
open(OLDERR, ">&STDERR");

# redirect stdout and stderr
open(STDOUT, "> /tmp/program.out")  or die "Can't redirect stdout: $!";
open(STDERR, ">&STDOUT")            or die "Can't dup stdout: $!";
}

sub LoadFriends {
my @Tmp ;
open (FRD,"$ConfFile") ;
while (<FRD>) {
chomp ;
@Tmp=split ('=') ;
$Nom{$Tmp[1]}=$Tmp[0] ;
}
close (FRD) ;
}
sub ListCmd {
foreach (keys (%Cmd) )
{
print "\t..$_..=>..$Cmd{$_}..\n"
}
}


sub AffMessage {

use Gtk ; init Gtk ;
use strict ;

###########
#### GTK
###########

my ($Message,$Exp) = @_ ;

my ($Main,$ScrolledWindow) ;
my ($Text,$VBox,$HBox) ;
my ($StickyBtn,$StickyPix,$PoubelleBtn,$PoubellePix,$Label) ;
my ($pixmap,$mask,$Style) ;
my $LabelName ;
my $Font = Gtk::Gdk::Font->load("-misc-fixed-medium-r-*-*-*-140-*-*-*-*-*-*");



    # Construction de la fentre 'Main'
    $Main = new Gtk::Window('toplevel');
    $Main->set_title('Sticky');
    $Main->position('center' );
    $Main->set_policy(0, 1, 0 );
    $Main->set_modal(0 );
    #~ $Main->set_border(10) ;
    $Main->realize;


	# Construct a GtkVBox 'VBox'
	$VBox = new Gtk::VBox(0, 0 );
	$Main->add($VBox );
	$VBox->show;

	    #
	    # Construct a GtkHBox 'HBox'
	    $HBox = new Gtk::HBox(0, 0 );
	    $VBox->add($HBox );
	    $HBox->show;

		#
		# Construct a GtkButton 'StickyBtn'
		$StickyBtn = new Gtk::Button();
		$StickyBtn->set_relief('none') ;
		$HBox->add($StickyBtn );
		$StickyBtn->show;
		$StickyBtn->can_focus(1);

		$Style = $Main->get_style()->bg('normal');
		( $pixmap, $mask ) = Gtk::Gdk::Pixmap->create_from_xpm_d( $Main->window, $Style, @PostIt );
		$StickyPix = new Gtk::Pixmap( $pixmap, $mask );
		$StickyPix->show();
		$StickyBtn->add( $StickyPix );

		$HBox->set_child_packing($StickyBtn, 0, 0, 0, 'start' );
		#
		# Construct a GtkLabel 'Label'
		$LabelName = $Nom{$Exp} || $Exp ;
		$Label = new Gtk::Label("From $LabelName !");
		$Label->set_justify('center' );
		$Label->set_line_wrap(0 );
		$HBox->add($Label );
		$Label->show;
		$Label->set_alignment(0.5, 0.5 );
		$HBox->set_child_packing($Label, 1, 1, 0, 'start' );
		#
		# Construct a GtkButton 'PoubelleBtn'
		$PoubelleBtn = new Gtk::Button();
		$HBox->add($PoubelleBtn );
		$PoubelleBtn->set_relief('none') ;
		$PoubelleBtn->show;
		$PoubelleBtn->can_focus(1 );

		$Style = $Main->get_style()->bg('normal');
		( $pixmap, $mask ) = Gtk::Gdk::Pixmap->create_from_xpm_d( $Main->window, $Style, @Poubelle );
		$PoubellePix = new Gtk::Pixmap( $pixmap, $mask );
		$PoubellePix->show();
		$PoubelleBtn->add( $PoubellePix );

		$HBox->set_child_packing($PoubelleBtn, 0, 0, 0, 'start' );
	    $VBox->set_child_packing($HBox, 0, 1, 0, 'start' );
	    #
	    # Construct a GtkScrolledWindow 'ScrolledWindow'
	    $ScrolledWindow = new Gtk::ScrolledWindow( undef, undef);
	    $ScrolledWindow->set_policy('never', 'always' );
	    $ScrolledWindow->border_width(0 );
	    $ScrolledWindow->hscrollbar->set_update_policy('discontinuous' );
	    $ScrolledWindow->vscrollbar->set_update_policy('discontinuous' );
	    $VBox->add($ScrolledWindow );
	    $ScrolledWindow->show;
	    #~ $forms->{'Main'}{'ScrolledWindow'} = $widgets->{'ScrolledWindow'};
		#
		# Construct a GtkText 'Text'
		$Text = new Gtk::Text( undef, undef );
		$Text->set_editable(0 );
		$Text->insert(undef, $Font, undef, $Message);
		$ScrolledWindow->add($Text );
		$Text->show;
		$Text->can_focus(1 );
	    $VBox->set_child_packing($ScrolledWindow, 1, 1, 0, 'start' );


$Main->show() ;

sub CloseApp {
   Gtk->exit(0) ;
   return 0;
}


## Signaux
##########
$Main->signal_connect("delete_event", \&CloseApp) ;
$PoubelleBtn->signal_connect("clicked", \&CloseApp) ;
main Gtk ;
}

